//
// Created by auric on 2/21/24.
//

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <nprint.h>
#include <sanity.h>
#include "config.h"
#include "debug.h"
#include "fex.h"

void help() {
    nprint("E", "Usage: fex (OPT) (PACKAGES)");
}

char* flagNames[] = {"INSTALL",  "SOURCE", "UNINSTALL", "LIST", "SEARCH", "FORCE", "UPGRADE"};

int main(int argc, char** argv) {
    unsigned int flags = 0;
    char* packages[argc - 1];
    int pkgCount = 0;

    if (argc < 2) {
        help();
        return 1;
    }

    for(int i = 1; i < argc; i++) {
        if(argv[i][0] == '-') {
            for(int j = 1; argv[i][j] != '\0'; j++) {
                switch(argv[i][j]) {
                    case 'i': // install, 0
                        flags |= FLAG_INSTALL;
                        break;
                    case 'S': // source, 1
                        flags |= FLAG_SOURCE;
                        break;
                    case 'r': // remove, 2
                        flags |= FLAG_UNINSTALL;
                        break;
                    case 'l': // list, 3
                        flags |= FLAG_LIST;
                        break;
                    case 's': // search, 4
                        flags |= FLAG_SEARCH;
                        break;
                    case 'f': // force, 5
                        flags |= FLAG_FORCE;
                        break;
                    case 'u': // upgrade, 6
                        flags |= FLAG_UPGRADE;
                        break;
                    default:
                        nprint("E", "Flag '%c' is unknown.", argv[i][j]);
                        return 1;
                }
            }
        } else {
            packages[pkgCount++] = argv[i];
        }
    }

    const int sysSanity = isSysSane();
    if ((isSyntaxSane(flags, pkgCount))) {
        return 1;
    }

#ifdef debugEnabled
        DEBUG_PRINT("sysSanity: %d", sysSanity);
        unsigned int flagValues[] = {0b0000001, 0b0000010, 0b0000100, 0b0001000, 0b0010000, 0b0100000, 0b1000000};
        int numFlags = sizeof(flagValues) / sizeof(flagValues[0]);
        for(int i = 0; i < numFlags; i++) {
            if (flags & flagValues[i]) {
                nprint("D", "%s flag is set.", flagNames[i]);
            } else {
                nprint("D", "%s flag is not set.", flagNames[i]);
            }
        }
        for(int i = 0; i < pkgCount; i++) {
            nprint("D", "Package %d: %s", i, packages[i]);
        }
    #endif

    /* End Prelogic */
    DEBUG_PRINT("[!] Break parselogic");

    for(int i = 0; i < numFlags; i++) {
        DEBUG_PRINT("Iterating over %s", flagNames[i]);

    }
    return 0;
}